<!DOCTYPE html>
<html lang="en">
<head>
    <style>
        :root {
            --black: oklch(0% 0 0);
            --white: oklch(100% 0 0);
            --red: oklch(61% 0.38 14);
        }
        html{
            scrollbar-color: #0000 #0000;
        }
        body::-webkit-scrollbar{
            display: none;
        }
        html, body{
            margin: 0;
            padding: 0;
        }
        body{
            background-color: var(--black);
        }
    </style>
</head>
<body>
    <script>
        window.dpr = window.devicePixelRatio;

        class CompBitrain extends HTMLElement{
            connectedCallback(){
                const sr = this.attachShadow({mode: 'open'});
                sr.innerHTML = `<canvas id="canvas" style="width: 100%; height: 100lvh;"></canvas>`;
                const canvas = sr.getElementById("canvas");
                const ctx = canvas.getContext("2d");
                const particleCount = 40;
                let particles;

                class Particle {
                    constructor(){
                        this.x = Math.random() * canvas.width;
                        this.y = Math.random() * canvas.height;
                        this.size = 3;
                        this.velocity = canvas.height * (Math.random() * 0.004 + 0.004);
                    }
                    /*
                    update(){
                        this.y = Math.round(this.y + (this.velocity * (1 - pixels[(this.y * canvas.width) + this.x] * 0.9)) + 0.1);
                        if(this.y >= canvas.height){
                            this.fill = "white";
                            this.count++
                            if(this.count == 8){
                                globalCount += 1;
                                this.y = 0;
                            }
                            else{
                                this.x = Math.round(Math.random() * canvas.width / pixelSize) * pixelSize;
                                this.y = 0
                            };
                        };
                    };
                    */
                    draw(){
                        ctx.beginPath();
                        ctx.arc(this.x, this.y, this.size * 40, 0, 2 * Math.PI);
                        ctx.stroke();
                    };
                };

                function canvasConfig(){
                    canvas.width = sr.getElementById("canvas").offsetWidth * dpr;
                    canvas.height = sr.getElementById("canvas").offsetHeight * dpr;
                    ctx.lineCap = "round";
                    ctx.lineWidth = dpr * 1;
                    ctx.strokeStyle = "#fff";
                    particles = [];
                    for(let i = 0; i < particleCount; i++){
                        particles.push(new Particle);
                    };
                };
                canvasConfig();

                function frame(){
                    for(let i = 0; i < particleCount; i++){
                        //particles[i].update();
                        particles[i].draw();
                    };
                };

                function animate(){
                    frame();
                    requestAnimationFrame(animate);
                };
                animate();
            };
        };

        window.customElements.define("comp-bitrain", CompBitrain);
    </script>

    <comp-bitrain></comp-bitrain>

</body>
</html>
